#ifndef _X_DEBUG_H__
#define _X_DEBUG_H__ 1

#include <keyboard_settings.h>

#if X_DEBUG > 0

#include <stdbool.h>
#include <stdio.h>
#include <avr/pgmspace.h>

extern volatile bool x_debug;

#define printf_debug(format, args...) if(x_debug) printf_P(PSTR(format), ## args)

#define X_DEBUG_TGL_KEY_STRUCT() uint8_t debug

#define X_DEBUG_TGL_KEY_INIT  .debug = X_SC_D,


#else

//If debug disabled, just let the function go to nowhere.
#define printf_debug(format, args...)

#define X_DEBUG_TGL_KEY_STRUCT()

#define X_DEBUG_TGL_KEY_INIT

#endif



#endif

