#include <keyboard_settings.h>

#if X_MOUSE > 0
#include "mouse.h"

#include <core/scancodes.h>
#include <core/x_scancodes.h>

x_mouse_table_s x_mouse_table EEMEM =
{
	.mouse_left  = MOUSE_LEFT,
	.mouse_right = MOUSE_RIGHT,
	.mouse_up    = MOUSE_UP,
	.mouse_down  = MOUSE_DOWN,
	.wheel_up    = WHEEL_UP,
	.wheel_down  = WHEEL_DOWN,
	.b1          = B1,
	.b2          = B2,
	.b3          = B3,
};

x_mouse_table_s x_mouse_table_backup EEMEM =
{
	.mouse_left  = 0,
	.mouse_right = 0,
	.mouse_up    = 0,
	.mouse_down  = 0,
	.b1          = 0,
	.b2          = 0,
	.b3          = 0,
};

x_mouse_info_t x_mouse_info =
{
	.mouse_mode = false,
	.mouse_jump = 1, //Width to let the mouse jump for every repeat
	.mouse_move_x = 0,
	.mouse_move_y = 0,
	.mouse_wheel = 0,
	.buttons_pressed = 0,
};

bool eval_mouse(uint8_t x_code)
{
	
	//Mouse movement
#if X_MOUSE_ANALOG_X == 0
	if(x_code == eeprom_read_byte(&x_mouse_table.mouse_left))
	{
		x_mouse_info.mouse_move_x = -x_mouse_info.mouse_jump;
		return true;
	}
	if(x_code == eeprom_read_byte(&x_mouse_table.mouse_right))
	{
		x_mouse_info.mouse_move_x = +x_mouse_info.mouse_jump;
		return true;
	}
#endif
#if X_MOUSE_ANALOG_Y == 0
	if(x_code == eeprom_read_byte(&x_mouse_table.mouse_down))
	{
		x_mouse_info.mouse_move_y = +x_mouse_info.mouse_jump;
		return true;
	}
	if(x_code == eeprom_read_byte(&x_mouse_table.mouse_up))
	{
		x_mouse_info.mouse_move_y = -x_mouse_info.mouse_jump;
		return true;
	}
#endif
#if X_MOUSE_ANALOG_WHEEL == 0
	//Mouse Wheel
	if(x_code == eeprom_read_byte(&x_mouse_table.wheel_up))
	{
		x_mouse_info.mouse_wheel++;
		return true;
	}
	if(x_code == eeprom_read_byte(&x_mouse_table.wheel_down))
	{
		x_mouse_info.mouse_wheel--;
		return true;
	}
#endif

	//Mouse buttons
	x_mouse_info.buttons_pressed = ((x_code == eeprom_read_byte(&x_mouse_table.b1)) << 0) |
	                               ((x_code == eeprom_read_byte(&x_mouse_table.b2)) << 1) |
	                               ((x_code == eeprom_read_byte(&x_mouse_table.b3)) << 2);

	return false;
}

#endif