#ifndef __X_CORE_H__
#define __X_CORE_H__ 1

#include <keyboard_settings.h>

#include <avr/eeprom.h>
#include <stdbool.h>
#include <stdint.h>
#include <core/macros/mouse.h>

#ifndef EEMEM
#define EEMEM
#endif


typedef struct x_keyboard_data_t
{
	volatile uint8_t keys[X_MAX_KEYS];
	volatile uint8_t n_keys;
	volatile uint8_t mod_byte;
} x_keyboard_data_t;



extern x_keyboard_data_t x_keyboard_data;
extern uint8_t x_keyboard_table[] EEMEM;

#include <core/macros/debug.h>
typedef struct x_macro_status_t
{
	bool modifiers_active;
	X_MOUSE_ACTIV_STRUCT(); //Use define to ENABLE/DISABLE function and avoid many #IF ... #ENDIF
} x_macro_status_t;

typedef struct x_macro_toggle_keys_t
{
	uint8_t modifiers;
	X_MOUSE_TGL_KEY_STRUCT();
	X_DEBUG_TGL_KEY_STRUCT();
} x_macro_toggle_keys_t;

extern x_macro_toggle_keys_t x_macro_toggle_keys EEMEM;
extern x_macro_status_t x_macro_status;


//Modifiers are implemented as macro but anyway it's core, so they will stay here...
typedef struct x_modifiers_t
{
	uint8_t modifier_leftctrl;
	uint8_t modifier_leftshift;
	uint8_t modifier_leftalt;
	uint8_t modifier_leftgui;
	uint8_t modifier_rightctrl;
	uint8_t modifier_rightshift;
	uint8_t modifier_rightalt;
	uint8_t modifier_rightgui;
} x_modifiers_t;

extern x_modifiers_t x_modifiers EEMEM;
extern x_modifiers_t x_modifiers_backup EEMEM;


void x_core_init(void);

void translate(uint8_t* rm_codes, uint8_t count);

#endif
