#ifndef _KEYBOARD_SETTINGS_H__
#define _KEYBOARD_SETTINGS_H__ 1
#include <usb/LUFA/Common/Architectures.h>

//signal log size
#define X_MAX_DATA_LENGTH             96

//X_MAX_KEYS will maximum be pressed simultaneous
#define X_MAX_KEYS                    4


//Mouse settings
#define X_MAX_MOUSE_MOVEMENT          5
#define X_MOUSE_MAX_SPEED             40

//Map keys not in xsc scancode list for available codes see scancodes.h
#define X_SC_SPECIAL_MAP1   0
#define X_SC_SPECIAL_MAP2   0
#define X_SC_SPECIAL_MAP3   0
#define X_SC_SPECIAL_MAP4   0
#define X_SC_SPECIAL_MAP5   0
#define X_SC_SPECIAL_MAP6   0
#define X_SC_SPECIAL_MAP7   0
#define X_SC_SPECIAL_MAP8   0
#define X_SC_SPECIAL_MAP9   0
#define X_SC_SPECIAL_MAP10  0

//Macro Settings
#if (ARCH == ARCH_XMEGA)
#define X_DEBUG              1
#define X_DEBUG_TGL_KEY      X_SC_D
#define X_DEBUG_DEFAULT_EN   0
#else
#define X_DEBUG              0
#define X_DEBUG_TGL_KEY      X_SC_D
#define X_DEBUG_DEFAULT_EN   0
#endif


#define X_MOUSE              1
#define X_MOUSE_TGL_KEY      X_SC_M
#define X_MOUSE_DEFAULT_EN   1



//Mouse settings
#define X_MOUSE_ANALOG_X     1
#define X_MOUSE_ANALOG_Y     1
#define X_MOUSE_ANALOG_WHEEL 0

#define MOUSE_LEFT          X_SC_SPECIAL1 //Can be mapped to same key because mouse is analog
#define MOUSE_RIGHT         X_SC_SPECIAL1 //but it has to be mapped to something
#define MOUSE_UP            X_SC_SPECIAL1
#define MOUSE_DOWN          X_SC_SPECIAL1
#define WHEEL_UP            X_SC_PAGE_UP
#define WHEEL_DOWN          X_SC_PAGE_DOWN
#define B1                  X_SC_SPECIAL2
#define B2                  X_SC_SPECIAL3
#define B3                  X_SC_LEFT_GUI



//Timer Prediv
//Please also change in merlin_hw
#define X_TIMER_DIV          8L
#define X_TIMEOUT_MS         5L


#endif