#ifndef _KEYBOARD_SETTINGS_H__
#define _KEYBOARD_SETTINGS_H__ 1


#define X_MAX_KEYS                    4

//General settings
#define X_MAX_DATA_LENGTH             96



//Timer Prediv
//Please also change in core.h
#define X_TIMER_DIV          8L
//This will be the timeout time in milli second for the ir signal
//means: X_TIMEOUT_MS milliseconds no signal -> transmission complete
//But also the intervall in which signal_timeout is being called
//there you can implement an custom timeout with counting up a
//variable you can also use a multiply of timeout ms
#define X_TIMEOUT_MS         5L


//Map keys to a usb scancode not in x scancode list for available codes see scancodes.h
#define X_SC_SPECIAL_MAP1   0
#define X_SC_SPECIAL_MAP2   0
#define X_SC_SPECIAL_MAP3   0
#define X_SC_SPECIAL_MAP4   0
#define X_SC_SPECIAL_MAP5   0
#define X_SC_SPECIAL_MAP6   0
#define X_SC_SPECIAL_MAP7   0
#define X_SC_SPECIAL_MAP8   0
#define X_SC_SPECIAL_MAP9   0
#define X_SC_SPECIAL_MAP10  0


//Macro Settings
#if (ARCH == ARCH_XMEGA)
#define X_DEBUG              1
#define X_DEBUG_TGL_KEY      X_SC_D
#define X_DEBUG_DEFAULT_EN   0
#else
#define X_DEBUG              0
#define X_DEBUG_TGL_KEY      X_SC_D
#define X_DEBUG_DEFAULT_EN   0
#endif

//Mouse settings
//Maximum delta for each report
#define X_MAX_MOUSE_MOVEMENT          5
//If mouse digital it will be faster over every key repeat while the mouse move key is pressed
//This will be the maximum delta for every key repeat
#define X_MOUSE_MAX_SPEED             40

#define X_MOUSE              1
#define X_MOUSE_TGL_KEY      X_SC_M
#define X_MOUSE_DEFAULT_EN   0

#define X_MOUSE_ANALOG_X     0
#define X_MOUSE_ANALOG_Y     0
#define X_MOUSE_ANALOG_WHEEL 0

//Mouse mapping
#define MOUSE_LEFT          X_SC_LEFT_ARROW
#define MOUSE_RIGHT         X_SC_RIGHT_ARROW
#define MOUSE_UP            X_SC_UP_ARROW
#define MOUSE_DOWN          X_SC_DOWN_ARROW
#define WHEEL_UP            X_SC_MEDIA_MUTE
#define WHEEL_DOWN          X_SC_SPECIAL1
#define B1                  X_SC_SPECIAL6
#define B2                  X_SC_PAGE_UP
#define B3                  X_SC_PAGE_DOWN

#endif